C       TEST OF QAGI
C          COMPUTE INTEGRAL OF EXP(-X)*COS(X*X)**2 ON [0,INFINITY)
C               RESULT IS 0.70260...
C
      INTEGER LIMIT,LENW
      PARAMETER(LIMIT=100,LENW=LIMIT*4)
      REAL BOUND,EPSABS,EPSREL,RESULT,ABSERR,WORK(LENW)
      INTEGER INF,NEVAL,IER,LAST,IWORK(LIMIT)
      EXTERNAL F
C
C       SET UNDERFLOWS TO ZERO--COMPILER DEPENDENT---
C     CALL UNDER0(.TRUE.)
      BOUND = 0.0
      INF = 1
      EPSABS = 0.0
      EPSREL = 1.E-5
      CALL QAGI(F,BOUND,INF,EPSABS,EPSREL,RESULT,ABSERR,NEVAL,
     *    IER,LIMIT,LENW,LAST,IWORK,WORK)
      WRITE(*,*)'RESULT, ABSERR, NEVAL, IER: '
      WRITE(*,*) RESULT, ABSERR, NEVAL, IER
      STOP
      END
C
      REAL FUNCTION F(X)
        REAL X,EXP,COS
        F = EXP(-X)*COS(X*X)**2
        RETURN
      END
